function NSGetModule(compMgr, fileSpec) { return MenuManipulatorModule; }

var MenuManipulatorModule = {
  CID: Components.ID("{4381b0c0-a68e-11d9-9669-0800200c9a66}"),
  contractID : "@dorando.at/menumanipulator;1",
  className  : "MenuManipulatorService",

  registerSelf: function (aComponentManager, aFileSpec, aLocation, aType) 
  {
    aComponentManager = aComponentManager.QueryInterface(Components.interfaces.nsIComponentRegistrar);

    aComponentManager.registerFactoryLocation(this.CID, this.className, this.contractID, aFileSpec, aLocation, aType);

    var CategoryManager = Components.classes["@mozilla.org/categorymanager;1"]
                                    .getService(Components.interfaces.nsICategoryManager);
    CategoryManager.addCategoryEntry("app-startup", this.className, "service," + this.contractID, true, true, null);
  },
  
  getClassObject: function (aComponentManager, aCID, aIID) 
  {
    if (!aIID.equals(Components.interfaces.nsIFactory)) throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

    if (aCID.equals(this.CID)) return this.factory;
    
    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  factory: {
    createInstance: function (aOuter, aIID)
    {
      if (aOuter != null) throw Components.results.NS_ERROR_NO_AGGREGATION;

      return new MenuManipulatorService();
    }
  },
  
  canUnload: function () { return true; }
};

function MenuManipulatorService() { }

MenuManipulatorService.prototype = {
  os: Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService),
  ps: Components.classes['@mozilla.org/preferences-service;1']
                .getService(Components.interfaces.nsIPrefService).getBranch("menumanipulator."),
  bug174320fixed: Components.interfaces.nsIDOMNSFeatureFactory ? true : false,
  haspageshow: Components.interfaces.nsIDOMPageTransitionEvent ? true : false,

  observe: function (aSubject, aTopic, aData) {
    if(aTopic == "app-startup") this.os.addObserver(this,"domwindowopened",false);
    else if(aTopic == "domwindowopened") {
      aSubject.menumanipulator = this;
      aSubject.addEventListener("load",this.load,this.bug174320fixed);
    }
  },

  load: function(event) {
    this.removeEventListener("load",this.menumanipulator.load,true);

    if(event.eventPhase == 2 && this.menumanipulator.bug174320fixed)
     if(this.menumanipulator.haspageshow)
      this.addEventListener("pageshow",this.menumanipulator.init,false);
     else
      this.setTimeout(this.menumanipulator.init,0);
    else
      this.addEventListener("load",this.menumanipulator.init,false);
  },

  init: function() {
    this.menumanipulator.document = this.document;

    // workaround for problems introduced by 300412
    if(this.addBookmarkMenuitems) {
     this.gNavigatorBundle = this.document.getElementById("bundle_browser");
     this.addBookmarkMenuitems();
     this.addBookmarkMenuitems = function(){}
    }

    try { this.getBrowser().mStrip.firstChild.nextSibling.id = "menumanipulator-tabcontext"; }catch(e){}

    this.menumanipulator.ID("//x:menuseparator[not(@id)] | "+
                            "id('menumanipulator-tabcontext')/x:menuseparator[not(@id)]","separator");
    this.menumanipulator.ID("//x:menu[not(@id)]/x:menupopup[not(@id)] | "+
                            "id('menumanipulator-tabcontext')/x:menupopup[not(@id)]","popup");

    if(this.menumanipulator.ps.prefHasUserValue(this.document.location))
      eval(this.menumanipulator.ps.getComplexValue(this.document.location,Components.interfaces.nsISupportsString).data,
           this.menumanipulator);

    this.menumanipulator.document = null;
    this.menumanipulator.node = null;
  },

  NSResolver: function() { return "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul" },

  nodes: function(path,type) { return this.document.evaluate(path, this.document, this.NSResolver, type, null); },

  Node: function(path) {
    this.node = this.nodes(path,8).singleNodeValue;
    if(this.node)
      this.node.menumanipulator = {path: path, set: []};
  },

  Set: function(attr, value) {
    if(this.node) {
      this.node.menumanipulator.set[attr] = value;
      this.node.setAttribute(attr, value);
    }
  },

  Move: function(path, index, fallbacks) {
    var relNode = this.nodes(path,8).singleNodeValue;

    if(this.node) if(relNode) {
      this.node.menumanipulator.moved = true;
      if(index == -1)
        relNode.parentNode.insertBefore(this.node,relNode);
      else if(index == -2) {
        relNode.appendChild(this.node);
      } else {
        relNode.insertBefore(this.node,relNode.childNodes[index]);
      }
    } else {
      if(fallbacks && fallbacks.length) this.Move(fallbacks.shift(), fallbacks.shift(), fallbacks);
    }
  },

  New: function(type, id) {
    this.node = this.document.createElement(type);
    if(id) this.node.id = id;
    this.node.menumanipulator = {path: 'id("'+id+'")', set: [], created: true};
  },

  ID: function(path, name) {
    var nodes = this.nodes(path,7);

    var i;
    for(i = 0; i < nodes.snapshotLength; i++)
      nodes.snapshotItem(i).id = "menumanipulator-" + name + "-" + i;
  }

}
